//+------------------------------------------------------------------+
//|                                              EventProcessor5.mq5 |
//|                                           Copyright 2014, denkir |
//|                           https://login.mql5.com/ru/users/denkir |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, denkir"
#property link      "https://login.mql5.com/ru/users/denkir"
#property version   "1.00"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum ENUM_BOOL
  {
   No=0,  // No
   Yes=1, // Yes
  };
//+------------------------------------------------------------------+
//| Iputs                                                            |
//+------------------------------------------------------------------+
sinput string Info_flags="+===--Process events--====+";   // +===--Process events--====+
input ENUM_BOOL InpIsEventObjectDelete=Yes;      // Process "Object delete"?

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- object delete
   bool is_obj_delete=false;
   if(InpIsEventObjectDelete)
      is_obj_delete=true;
   ChartSetInteger(0,CHART_EVENT_OBJECT_DELETE,is_obj_delete);

//---
   return INIT_SUCCEEDED;
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   Comment("");
  }
//+------------------------------------------------------------------+
void OnChartEvent(const int id,//  :
                  const long   &lparam,
                  const double &dparam,
                  const string &sparam
                  )
  {
   string comment=" : ";

//---   
   switch(id)
     {
      //--- 1
      case CHARTEVENT_KEYDOWN:
        {
         comment+="1)  ";
         //---
         break;
        }
      //--- 2
      case CHARTEVENT_MOUSE_MOVE:
        {
         comment+="2) ";
         //---
         break;
        }
      //--- 3
      case CHARTEVENT_OBJECT_CREATE:
        {
         comment+="3)   ";
         //---
         break;
        }
      //--- 4
      case CHARTEVENT_OBJECT_CHANGE:
        {
         comment+="4)      ";
         //---
         break;
        }
      //--- 5
      case CHARTEVENT_OBJECT_DELETE:
        {
         comment+="5)   ";
         //---      
         if(InpIsEventObjectDelete)
           {
            int vert_lines_num=ObjectsTotal(0,0,OBJ_VLINE);
            PrintFormat("   : %d",vert_lines_num);

            //---
            string curr_obj_name=sparam;
            //---   
            if(ObjectFind(0,curr_obj_name)<0)
              {
               //---    
               int deleted_vert_lines_num=ObjectsDeleteAll(0,0,OBJ_VLINE);
               PrintFormat("    : %d",deleted_vert_lines_num);
               //---  
               Sleep(125);
               ChartRedraw();
               //---
               vert_lines_num=ObjectsTotal(0,0,OBJ_VLINE);
               PrintFormat("   : %d",vert_lines_num);
              }
           }
         //---
         break;
        }
      //--- 6
      case CHARTEVENT_CLICK:
        {
         comment+="6)    ";
         //---
         break;
        }
      //--- 7
      case CHARTEVENT_OBJECT_CLICK:
        {
         comment+="7)     ";
         //---
         break;
        }
      //--- 8
      case CHARTEVENT_OBJECT_DRAG:
        {
         comment+="8)      ";
         //---
         break;
        }
      //--- 9
      case CHARTEVENT_OBJECT_ENDEDIT:
        {
         comment+="9)   ";
         //---
         break;
        }
      //--- 10
      case CHARTEVENT_CHART_CHANGE:
        {
         comment+="10)  ";
         //---
         break;
        }
     }

//---
   Comment(comment);
  }
//+------------------------------------------------------------------+
